******代码如下：******
set more off
******控制变量处理******
gen second_industry_prop = 第二产业增加值_万元 / 地区生产总值_万元
gen popula_density = 户籍人口_万人/ 行政区域面积_平方公里 
gen per_income = 地区生产总值_万元 / 户籍人口_万人
gen popudensity_second = 第二产业从业人员_人/10000/ 户籍人口_万人
gen budget_expense =  一般公共预算支出_万元+1
gen ln_se_industry= ln(第二产业增加值_万元 / 地区生产总值_万元)
gen ln_pop_density=ln( 户籍人口_万人/ 行政区域面积_平方公里)
gen ln_perGDP=ln( 地区生产总值_万元 / 户籍人口_万人)
gen ln_pop_se=ln(第二产业从业人员_人/10000/ 户籍人口_万人)
gen ln_bud_exp=ln( 一般公共预算支出_万元+1 )


******表1基准回归******
******1-1基准回归******
reghdfe is_existed CTD, absorb( id year) vce(cluster county)
******1-2基准回归******
reghdfe is_existed CTD, absorb( id year c.ln_pop_density##i.year c.ln_bud_exp##i.year c.ln_perGDP##i.year) vce(cluster county)
******1-3基准回归******
reghdfe is_existed CTD, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)
******1-4 logit检验******
duplicates drop id year,force
xtset id year
xtlogit is_existed CTD year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year,fe


******图1平行趋势及动态趋势检验（累积效应）******
reghdfe is_existed pre33 pre2 current post1 post2 post3 post4 post5 post6 post7 post8 post9, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)
coefplot wpx0001, keep(pre33 pre1 pre2 current post1 post2 post3 post4 post5) vertical recast(connect) lcolor(black) lpattern(solid) ciopts(lpattern(solid) recast(rcap) lcolor(black)) mlcolor(black) mfcolor(black) msize(*1.2) msymbol(h) yline(0, lcolor(black) lwidth(*1.0)) xtitle("改革之前（pre）、改革当期（current）、改革之后（post）") graphregion(color(white)) plotr(lcolor(black) lpattern(1) lwidth(*1.5))

******图2平行趋势及动态趋势检验（增量效应）******
reghdfe new_site pre33 pre2 current post1 post2 post3 post4 post5 post6 post7 post8 post9, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)
coefplot wpx0001_new_site, keep(pre33 pre1 pre2 current post1 post2 post3 post4 post5) vertical recast(connect) lcolor(black) lpattern(solid) ciopts(lpattern(solid) recast(rcap) lcolor(black)) mlcolor(black) mfcolor(black) msize(*1.2) msymbol(h) yline(0, lcolor(black) lwidth(*1.0)) xtitle("改革之前（pre）、改革当期（current）、改革之后（post）") graphregion(color(white)) plotr(lcolor(black) lpattern(1) lwidth(*1.5))

******表2稳健性检验1******
******2-1纳入直辖市******采用纳入直辖市数据
reghdfe is_existed CTD, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county) 
******2-2去除自治区******采用去除自治区数据
reghdfe is_existed CTD, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county) 
******2-3剔除一直存在站点******
gen yzcz = is_existed * year 
gen yzcz01 = 1 if yzcz != 0
replace yzcz01 = 0 if yzcz01 == .
gen yzczid = yzcz01 * id
bys yzczid : gen number=_N
drop if number == 6
reghdfe is_existed  CTD, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******2-4只保留样本期内撤县设区改革******
drop if shifou == 2011
drop if shifou == 2012
drop if shifou == 2013
reghdfe is_existed CTD, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)
******2-5在地市层级度量CTD改革******
reghdfe is_existed CTD_dishi, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)
******2-6地市当年CTD数量******
reghdfe is_existed CTD_dishisl, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)
******2-7使用县域站点数量作为被解释变量******
bysort county year: egen shuliang= sum(is_existed)
bysort year county: gen n = _n
keep if n == 1
gen lnsl = ln(shuliang)
replace lnsl = 0 if lnsl == .
reghdfe lnsl CTD, absorb( county year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)

******表3排除干扰政策影响******
******3-1控制政府驻地迁移政策******
reghdfe is_existed  CTD Relocation_ddd, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******3-2控制县级市政策******
reghdfe is_existed  CTD CTC, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******3-3同时控制两个政策******
reghdfe is_existed  CTD Relocation_ddd CTC, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******3-4 PSM-DID******
ssc install psmatch2,replace
psmatch2 CTD ln_pop_density ln_pop_se ln_bud_exp ln_se_industry ln_perGDP,outcome(is_existed) logit ate neighbor(1) common caliper(.05) ties 
pstest ln_pop_density ln_pop_se ln_bud_exp ln_se_industry ln_perGDP ,both graph
*匹配前核密度图[概率密度图，数据的分布]
twoway (kdensity _ps if _treat==1,lp(solid) lw(*2.5)) (kdensity _ps if _treat==0,lp(dash) lw(*2.5)), ytitle("Density", size(*1.1)) ylabel(,angle(0) labsize(*1.1))  xtitle("Propensity Score", size(*1.1)) xscale(titlegap(2))  xlabel(0(0.2)0.8, format(%2.1f) labsize(*1.1)) legend(label(1 "Treatment Group") label(2 "Controls Group") row(2) position(10) ring(0) size(*1.1)) scheme(s1mono)
*匹配后核密度图
 twoway (kdensity _ps if _treat==1,lp(solid) lw(*2.5)) (kdensity _ps if _wei!=1 & _wei!=.,lp(dash) lw(*2.5)), ytitle("Density", size(*1.1)) ylabel(,angle(0) labsize(*1.1)) xtitle("Propensity Score", size(*1.1)) xscale(titlegap(2)) xlabel(0(0.2)0.8, format(%2.1f) labsize(*1.1)) legend(label(1 "Treatment Group") label(2 "Controls Group") row(2) position(10) ring(0) size(*1.1)) scheme(s1mono) 
 graph export "kn02_large.png",as(png)///
              replace fontface("Times New Roman")
*DID
gen common=_support
drop if common == 0  
reghdfe is_existed CTD ln_se_industry ln_pop_density ln_perGDP ln_pop_se ln_bud_exp , absorb(i._year _id) vce(cluster )
reghdfe is_existed  CTD, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
est sto DID 
outreg2 using wjx2_2.doc,keep(ydyl_after) append addtext(Firm FE, YES, Year FE, YES, Controls*t, YES)

******图3安慰剂检验******
forvalue i=1/100{
    sysuse 没有删除直辖市的2020最新公交车数据.dta, clear  //调入数据
    *- 思路：打乱rep78,即将rep78的全部取值拿出暂存，然后随机赋给每一个样本

    *- 打乱rep78,即将rep78的全部取值拿出暂存
    g obs_id= _n //初始样本序号
    gen random_digit= runiform() //生成随机数
    sort random_digit  //按新生成的随机数排序
    g random_id= _n  //产生随机序号
    preserve
        keep random_id CTD //保留虚拟的rep78
        rename CTD random_CTD
        rename random_id idd //重命名为id，以备与其他变量合并（merge）
        label var idd 原数据与虚拟处理变量的唯一匹配码
        save random_CTD, replace
    restore 
        drop random_digit random_id CTD //删除原来的rep78
        rename obs_id idd //重命名为id，以备与random_rep78合并（merge）
        label var idd 原数据与虚拟处理变量的唯一匹配码
        save rawdata, replace 

    *- 合并，回归，提取系数
        use rawdata, clear
        merge 1:1 idd using random_CTD,nogen
        reg  is_existed random_CTD ln_se_industry ln_pop_density ln_perGDP ln_pop_se ln_bud_exp 
        g _b_random_CTD= _b[random_CTD]  //提取x的回归系数
        g _se_random_CTD= _se[random_CTD] //提取x的标准误
        keep _b_random_CTD _se_random_CTD 
        duplicates drop _b_random_CTD, force
        save placebo`i', replace  //把第i次placebo检验的系数和标准误存起来
    }
*- 纵向合并1000次的系数和标准误 
use placebo1, clear
forvalue i=2/100{
    append using placebo`i' //纵向合并1000次回归的系数及标准误
}  
 
gen tvalue= _b_random_CTD/ _se_random_CTD
kdensity tvalue, xtitle("t值") ytitle("分布") saving(placebo_test) 
    
*-删除临时文件
forvalue i=1/100{
    erase  placebo`i'.dta 
} 

******异质性分析******
******4-1官话方言******
reghdfe is_existed  CTD if 方言大区 == "官话", absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******4-2非官话方言******
reghdfe is_existed  CTD if 方言大区 != "官话", absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******4-3低政策不确定******
reghdfe is_existed  CTD if standard <= 14.79687595, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******4-4高政策不确定******
reghdfe is_existed  CTD if standard > 14.79687595, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )

******5-1强县-县级市******
reghdfe is_existed  CTD if xian == 0, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******5-2弱县*****
reghdfe is_existed  CTD if xian == 1, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******5-3强省*****
reghdfe is_existed  CTD if fushengjishenghui == 1, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******5-4弱省*****
reghdfe is_existed  CTD if fushengjishenghui == 0, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )

******6-1强市-强县*****	
reghdfe is_existed  CTD if fushengjishenghui == 1 & xianjishi == 1, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******6-2强市-弱县*****		
reghdfe is_existed  CTD if fushengjishenghui == 1 & xian == 1, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******6-3东部-强县*****			
reghdfe is_existed  CTD if dongbu == 1 & xianjishi == 1, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******6-4非东部-强县*****	
reghdfe is_existed  CTD if dongbu != 1 & xianjishi == 1, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )

******影响机制******影响机制基于全样本数据进行回归
******7-1控制站点内企业数量******
reghdfe is_existed CTD ln_firm_num_1km, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)
******7-2控制站点内人口数量******
reghdfe is_existed CTD ln_pop_num_1km, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)
******7-3控制站点内人口、企业数量******
reghdfe is_existed CTD ln_firm_num_1km ln_pop_num_1km, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county)

******8-1地市层级******
reghdfe is_existed CTD_dishi, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster province)
******8-2区级******
reghdfe is_existed CTD_dishi if qu == 1, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster province)
******8-3县级******
reghdfe is_existed CTD_dishi if qu == 0, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster province)

******9-1省级******
reghdfe is_existed CTD_shengji, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster province)
******9-2省级数量******
reghdfe is_existed CTD_shengjisl, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster province)
******9-3不包括 "受政策影响后的地市" ******
reghdfe is_existed CTD_shengji if CTD_dishi == 0, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster province)
******9-4不包括 "受政策影响后的地市" ******
reghdfe is_existed CTD_shengjisl if CTD_dishi == 0, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster province)
******9-5不包括 "整个样本期受政策影响的地市"******
reghdfe is_existed CTD_shengji if youguo==0, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster province)
******9-6不包括 "整个样本期受政策影响的地市"******
reghdfe is_existed CTD_shengjisl if youguo==0, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster province)

******改革意愿和经济实力作用的再验证******
gen CTD_passive = CTD * fsbd
gen CTD_positive = CTD*fszd
******10-1主动改革******
reghdfe is_existed  CTD CTD_positive, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******10-2被动改革******
reghdfe is_existed  CTD CTD_passive, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******10-3改革意愿交互项******
reghdfe is_existed CTD_positive CTD_passive, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******10-4百强县******
gen CTD_baiqiang = CTD * fsbq
reghdfe is_existed  CTD CTD_baiqiang, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******10-5非百强县******
gen CTD_normal = CTD * fsfbq
reghdfe is_existed   CTD CTD_normal, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
******10-6经济实力交互项******
reghdfe is_existed  CTD_baiqiang CTD_normal, absorb( id year c.ln_pop_density##i.year c.ln_pop_se##i.year c.ln_bud_exp##i.year c.ln_se_industry##i.year c.ln_perGDP##i.year) vce(cluster county )
